// Das Namensraumobjekt erzeugen.
var security;
if (!security) security = {};

(function(modul) {
	//export
	security.md5 = md5;
    security.md5_utf8 = md5_utf8;


	/* md5.js - MD5 Message-Digest
	 * Copyright (C) 1999,2002 Masanao Izumo <mo@goice.co.jp>
	 * Version: 2.0.1
	 * LastModified: Dec 07 2004
	 *
	 * This program is free software.  You can redistribute it and/or modify
	 * it without any warranty.  This library calculates the MD5 based on RFC1321.
	 * See RFC1321 for more information and algorism.
	 */

	/* Interface:
	 * md5_128bits = MD5_hash(data);
	 * md5_hexstr = MD5_hexhash(data);
	 */

	/* ChangeLog
	 * 2004/12/07: Removed/optimized code for size and speed - fidian
	 * 2002/05/13: Version 2.0.0 released
	 * NOTICE: API is changed.
	 * 2002/04/15: Bug fix about MD5 length.
	 */

	var MD5_T = new Array(65);
	for (i = 0; i < 65; i++) {
		MD5_T[i] = parseInt(Math.abs(Math.sin(i)) * 4294967296.0)
	}

	var MD5_round1 = new Array(16);
	var MD5_round2 = new Array(16);
	var MD5_round3 = new Array(16);
	var MD5_round4 = new Array(16);
	var j = new Array(7, 12, 17, 22, 5, 9, 14, 20, 4, 11, 16, 23, 6, 10, 15, 21);
	for (i = 0; i < 16; i++) {
		MD5_round1[i] = new Array(i, j[i & 0x03], i + 1);
		MD5_round2[i] = new Array((1 + (i * 5)) % 16, j[(i & 0x03) + 4], i + 17);
		MD5_round3[i] = new Array((5 + (i * 3)) % 16, j[(i & 0x03) + 8], i + 33);
		MD5_round4[i] = new Array((i * 7) % 16, j[(i & 0x03) + 12], i + 49);
	}

	function MD5_F(x, y, z) {
		return (x & y) | (~x & z);
	}

	function MD5_G(x, y, z) {
		return (x & z) | (y & ~z);
	}

	function MD5_H(x, y, z) {
		return x ^ y ^ z;
	}

	function MD5_I(x, y, z) {
		return y ^ (x | ~z);
	}

	var MD5_round = new Array(new Array(MD5_F, MD5_round1),
		new Array(MD5_G, MD5_round2),
		new Array(MD5_H, MD5_round3),
		new Array(MD5_I, MD5_round4));

	function MD5_pack(n32) {
		return String.fromCharCode(n32 & 0xff) +
			String.fromCharCode((n32 >>> 8) & 0xff) +
			String.fromCharCode((n32 >>> 16) & 0xff) +
			String.fromCharCode((n32 >>> 24) & 0xff);
	}

	function MD5_number(n) {
		while (n < 0)
			n += 4294967296;
		while (n > 4294967295)
			n -= 4294967296;
		return n;
	}

	function MD5_apply_round(x, s, f, abcd, r) {
		var t;

		t = MD5_number(s[abcd[0]] +
			f(s[abcd[1]], s[abcd[2]], s[abcd[3]]) +
			x[r[0]] + MD5_T[r[2]]);
		s[abcd[0]] = MD5_number(((t << r[1]) | (t >>> (32 - r[1]))) + s[abcd[1]]);
	}

	function MD5_hash(data) {
		var abcd, x, state, s;
		var len, index, padLen, f, r;
		var i, j, k;
		var tmp;

		state = new Array(0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476);
		len = data.length;
		index = len & 0x3f;
		padLen = (index < 56) ? (56 - index) : (120 - index);
		if (padLen > 0) {
			data += "\x80";
			for (i = 0; i < padLen - 1; i++)
				data += "\x00";
		}
		data += MD5_pack(len * 8);
		data += MD5_pack(0);
		len += padLen + 8;
		abcd = new Array(0, 1, 2, 3);
		x = new Array(16);
		s = new Array(4);

		for (k = 0; k < len; k += 64) {
			for (i = 0, j = k; i < 16; i++, j += 4) {
				x[i] = data.charCodeAt(j) |
					(data.charCodeAt(j + 1) << 8) |
					(data.charCodeAt(j + 2) << 16) |
					(data.charCodeAt(j + 3) << 24);
			}
			s[0] = state[0];
			s[1] = state[1];
			s[2] = state[2];
			s[3] = state[3];
			for (i = 0; i < 4; i++) {
				f = MD5_round[i][0];
				r = MD5_round[i][1];
				for (j = 0; j < 16; j++) {
					MD5_apply_round(x, s, f, abcd, r[j]);
					tmp = abcd[0];
					abcd[0] = abcd[3];
					abcd[3] = abcd[2];
					abcd[2] = abcd[1];
					abcd[1] = tmp;
				}
			}

			state[0] = MD5_number(state[0] + s[0]);
			state[1] = MD5_number(state[1] + s[1]);
			state[2] = MD5_number(state[2] + s[2]);
			state[3] = MD5_number(state[3] + s[3]);
		}

		return MD5_pack(state[0]) +
			MD5_pack(state[1]) +
			MD5_pack(state[2]) +
			MD5_pack(state[3]);
	}

	function md5(data, salt) {
		var i, out, c;
		var bit128;

		bit128 = MD5_hash(data + (salt ? salt : ""));
		out = "";
		for (i = 0; i < 16; i++) {
			c = bit128.charCodeAt(i);
			out += "0123456789abcdef".charAt((c >> 4) & 0xf);
			out += "0123456789abcdef".charAt(c & 0xf);
		}
		return out;
	}


	var mapping = [];
	mapping['0'] = 'z'
	mapping['1'] = '5'
	mapping['2'] = 'l'
	mapping['3'] = 'm'
	mapping['4'] = 'W'
	mapping['5'] = 'w'
	mapping['6'] = 's'
	mapping['7'] = 'n'
	mapping['8'] = 'H'
	mapping['9'] = '3'
	mapping['A'] = 'B'
	mapping['B'] = '4'
	mapping['C'] = 'o'
	mapping['D'] = 'N'
	mapping['E'] = 'V'
	mapping['F'] = 'E'
	mapping['G'] = 'z'
	mapping['H'] = '6'
	mapping['I'] = 'i'
	mapping['J'] = '2'
	mapping['K'] = 'f'
	mapping['L'] = 'M'
	mapping['M'] = 'v'
	mapping['N'] = 'u'
	mapping['O'] = 'O'
	mapping['P'] = 'C'
	mapping['Q'] = 'K'
	mapping['R'] = 'F'
	mapping['S'] = '8'
	mapping['T'] = 'U'
	mapping['U'] = 'j'
	mapping['V'] = '7'
	mapping['W'] = 'e'
	mapping['X'] = 'L'
	mapping['Y'] = 'G'
	mapping['Z'] = 'P'
	mapping['a'] = 'x'
	mapping['b'] = 'g'
	mapping['c'] = '9'
	mapping['d'] = 'p'
	mapping['e'] = 'b'
	mapping['f'] = 'd'
	mapping['g'] = 'y'
	mapping['h'] = '0'
	mapping['i'] = 'D'
	mapping['j'] = 'h'
	mapping['k'] = 'a'
	mapping['l'] = 'S'
	mapping['m'] = 'r'
	mapping['n'] = '1'
	mapping['o'] = 'J'
	mapping['p'] = 'c'
	mapping['q'] = 'x'
	mapping['r'] = 'q'
	mapping['s'] = 'Q'
	mapping['t'] = 'T'
	mapping['u'] = 'I'
	mapping['v'] = 't'
	mapping['w'] = 'k'
	mapping['x'] = 'y'
	mapping['y'] = 'R'
	mapping['z'] = 'A'


	var chartable = ['z', '5', 'l', 'm', 'W', 'w', 's', 'n', 'H', '3', 'B', '4', 'o', 'N', 'V', 'E', 'z', '6', 'i', '2', 'f', 'M', 'v', 'u', 'O', 'C', 'K', 'F', '8', 'U', 'j', '7', 'e', 'L', 'G', 'P', 'x', 'g', '9', 'p', 'b', 'd', 'y', '0', 'D', 'h', 'a', 'S', 'r', '1', 'J', 'c', 'x', 'q', 'Q', 'T', 'I', 't', 'k', 'R', 'y', 'A']
	var offsettable = [];
	offsettable['0'] = 32
	offsettable['1'] = 2
	offsettable['2'] = 42
	offsettable['3'] = 38
	offsettable['4'] = 4
	offsettable['5'] = 42
	offsettable['6'] = 35
	offsettable['7'] = 17
	offsettable['8'] = 42
	offsettable['9'] = 10
	offsettable['A'] = 29
	offsettable['B'] = 9
	offsettable['C'] = 9
	offsettable['D'] = 12
	offsettable['E'] = 41
	offsettable['F'] = 11
	offsettable['G'] = 21
	offsettable['H'] = 31
	offsettable['I'] = 55
	offsettable['J'] = 1
	offsettable['K'] = 44
	offsettable['L'] = 42
	offsettable['M'] = 41
	offsettable['N'] = 29
	offsettable['O'] = 26
	offsettable['P'] = 3
	offsettable['Q'] = 36
	offsettable['R'] = 8
	offsettable['S'] = 16
	offsettable['T'] = 17
	offsettable['U'] = 54
	offsettable['V'] = 10
	offsettable['W'] = 27
	offsettable['X'] = 5
	offsettable['Y'] = 52
	offsettable['Z'] = 11
	offsettable['a'] = 17
	offsettable['b'] = 31
	offsettable['c'] = 40
	offsettable['d'] = 40
	offsettable['e'] = 48
	offsettable['f'] = 55
	offsettable['g'] = 32
	offsettable['h'] = 18
	offsettable['i'] = 47
	offsettable['j'] = 28
	offsettable['k'] = 7
	offsettable['l'] = 10
	offsettable['m'] = 14
	offsettable['n'] = 38
	offsettable['o'] = 7
	offsettable['p'] = 13
	offsettable['q'] = 11
	offsettable['r'] = 1
	offsettable['s'] = 21
	offsettable['t'] = 32
	offsettable['u'] = 15
	offsettable['v'] = 30
	offsettable['w'] = 35
	offsettable['x'] = 3
	offsettable['y'] = 12
	offsettable['z'] = 33

	function salt(data) {
		if (!data) data = "";

		var salt = "";
		var offset = offsettable[15];
		for (var i = 0; i < data.length; i++) {
			var o = offsettable[data.charAt(i)] + data.length;
			if (o) {
				offset = o;
				break;
			}
		}


		for (var i = 0; i <= 30; i++) {
			if (data.length > i) {
				var mapp = mapping[data.charAt(i)];

				if (!mapp) mapp = data.charAt(i);
				else {
					for (var j = 0; j < i; j++) {
						mapp = mapping[mapp];
					}
				}

				salt += mapp;
			} else {
				salt += chartable[(i + offset + data.length) % (chartable.length - 1)];
			}
		}

		return salt;
	}

	/*
 Javascript MD5 library - version 0.4

 Coded (2011) by Luigi Galli - LG@4e71.org - http://faultylabs.com

 Thanks to: Roberto Viola

 The below code is PUBLIC DOMAIN - NO WARRANTY!

 Changelog: 
            Version 0.4   - 2011-06-19
            + added compact version (md5_compact_min.js), this is a slower but smaller version 
              (more than 4KB lighter before stripping/minification)
            + added preliminary support for Typed Arrays (see: 
              https://developer.mozilla.org/en/JavaScript_typed_arrays and 
              http://www.khronos.org/registry/typedarray/specs/latest/)
              MD5() now accepts input data as ArrayBuffer, Float32Array, Float64Array, 
              Int16Array, Int32Array, Int8Array, Uint16Array, Uint32Array or Uint8Array 
            - moved unit tests to md5_test.js
            - minor refactoring 

            Version 0.3.* - 2011-06-##
            - Internal dev versions

            Version 0.2 - 2011-05-22 
            ** FIXED: serious integer overflow problems which could cause a wrong MD5 hash being returned

            Version 0.1 - 2011
            -Initial version

    Computes the MD5 hash for the given input data

    input :  data as String - (Assumes Unicode code points are encoded as UTF-8. If you 
                               attempt to digest Unicode strings using other encodings 
                               you will get incorrect results!)

             data as array of characters - (Assumes Unicode code points are encoded as UTF-8. If you 
                              attempt to digest Unicode strings using other encodings 
                              you will get incorrect results!)

             data as array of bytes (plain javascript array of integer numbers)

             data as ArrayBuffer (see: https://developer.mozilla.org/en/JavaScript_typed_arrays)
            
             data as Float32Array, Float64Array, Int16Array, Int32Array, Int8Array, Uint16Array, Uint32Array or Uint8Array (see: https://developer.mozilla.org/en/JavaScript_typed_arrays)
             
             (DataView is not supported yet)

   output: MD5 hash (as Hex Uppercase String)
*/
	function md5_utf8(data) {
		// convert number to (unsigned) 32 bit hex, zero filled string
		function to_zerofilled_hex(n) {
			var t1 = (n >>> 0).toString(16)
			return "00000000".substr(0, 8 - t1.length) + t1
		}

		// convert array of chars to array of bytes 

		function chars_to_bytes(ac) {
			var retval = []
			for (var i = 0; i < ac.length; i++) {
				retval = retval.concat(str_to_bytes(ac[i]))
			}
			return retval
		}


		// convert a 64 bit unsigned number to array of bytes. Little endian

		function int64_to_bytes(num) {
			var retval = []
			for (var i = 0; i < 8; i++) {
				retval.push(num & 0xFF)
				num = num >>> 8
			}
			return retval
		}

		//  32 bit left-rotation

		function rol(num, places) {
			return ((num << places) & 0xFFFFFFFF) | (num >>> (32 - places))
		}

		// The 4 MD5 functions

		function fF(b, c, d) {
			return (b & c) | (~b & d)
		}

		function fG(b, c, d) {
			return (d & b) | (~d & c)
		}

		function fH(b, c, d) {
			return b ^ c ^ d
		}

		function fI(b, c, d) {
			return c ^ (b | ~d)
		}

		// pick 4 bytes at specified offset. Little-endian is assumed

		function bytes_to_int32(arr, off) {
			return (arr[off + 3] << 24) | (arr[off + 2] << 16) | (arr[off + 1] << 8) | (arr[off])
		}

		/*
    Conver string to array of bytes in UTF-8 encoding
    See: 
    http://www.dangrossman.info/2007/05/25/handling-utf-8-in-javascript-php-and-non-utf8-databases/
    http://stackoverflow.com/questions/1240408/reading-bytes-from-a-javascript-string
    How about a String.getBytes(<ENCODING>) for Javascript!? Isn't it time to add it?
    */

		function str_to_bytes(str) {
			var retval = []
			for (var i = 0; i < str.length; i++)
				if (str.charCodeAt(i) <= 0x7F) {
					retval.push(str.charCodeAt(i))
				} else {
					var tmp = encodeURIComponent(str.charAt(i)).substr(1).split('%')
					for (var j = 0; j < tmp.length; j++) {
						retval.push(parseInt(tmp[j], 0x10))
					}
				}
			return retval
		}


		// convert the 4 32-bit buffers to a 128 bit hex string. (Little-endian is assumed)

		function int128le_to_hex(a, b, c, d) {
			var ra = ""
			var t = 0
			var ta = 0
			for (var i = 3; i >= 0; i--) {
				ta = arguments[i]
				t = (ta & 0xFF)
				ta = ta >>> 8
				t = t << 8
				t = t | (ta & 0xFF)
				ta = ta >>> 8
				t = t << 8
				t = t | (ta & 0xFF)
				ta = ta >>> 8
				t = t << 8
				t = t | ta
				ra = ra + to_zerofilled_hex(t)
			}
			return ra
		}

		// conversion from typed byte array to plain javascript array 

		function typed_to_plain(tarr) {
			var retval = new Array(tarr.length)
			for (var i = 0; i < tarr.length; i++) {
				retval[i] = tarr[i]
			}
			return retval
		}

		// check input data type and perform conversions if needed
		var databytes = null
		// String
		var type_mismatch = null
		if (typeof data == 'string') {
			// convert string to array bytes
			databytes = str_to_bytes(data)
		} else if (data.constructor == Array) {
			if (data.length === 0) {
				// if it's empty, just assume array of bytes
				databytes = data
			} else if (typeof data[0] == 'string') {
				databytes = chars_to_bytes(data)
			} else if (typeof data[0] == 'number') {
				databytes = data
			} else {
				type_mismatch = typeof data[0]
			}
		} else if (typeof ArrayBuffer != 'undefined') {
			if (data instanceof ArrayBuffer) {
				databytes = typed_to_plain(new Uint8Array(data))
			} else if ((data instanceof Uint8Array) || (data instanceof Int8Array)) {
				databytes = typed_to_plain(data)
			} else if ((data instanceof Uint32Array) || (data instanceof Int32Array) ||
				(data instanceof Uint16Array) || (data instanceof Int16Array) ||
				(data instanceof Float32Array) || (data instanceof Float64Array)
			) {
				databytes = typed_to_plain(new Uint8Array(data.buffer))
			} else {
				type_mismatch = typeof data
			}
		} else {
			type_mismatch = typeof data
		}

		if (type_mismatch) {
			alert('MD5 type mismatch, cannot process ' + type_mismatch)
		}

		function _add(n1, n2) {
			return 0x0FFFFFFFF & (n1 + n2)
		}


		return do_digest()

		function do_digest() {

			// function update partial state for each run
			function updateRun(nf, sin32, dw32, b32) {
				var temp = d
				d = c
				c = b
				//b = b + rol(a + (nf + (sin32 + dw32)), b32)
				b = _add(b,
					rol(
						_add(a,
							_add(nf, _add(sin32, dw32))
						), b32
					)
				)
				a = temp
			}

			// save original length
			var org_len = databytes.length

			// first append the "1" + 7x "0"
			databytes.push(0x80)

			// determine required amount of padding
			var tail = databytes.length % 64
			// no room for msg length?
			if (tail > 56) {
				// pad to next 512 bit block
				for (var i = 0; i < (64 - tail); i++) {
					databytes.push(0x0)
				}
				tail = databytes.length % 64
			}
			for (i = 0; i < (56 - tail); i++) {
				databytes.push(0x0)
			}
			// message length in bits mod 512 should now be 448
			// append 64 bit, little-endian original msg length (in *bits*!)
			databytes = databytes.concat(int64_to_bytes(org_len * 8))

			// initialize 4x32 bit state
			var h0 = 0x67452301
			var h1 = 0xEFCDAB89
			var h2 = 0x98BADCFE
			var h3 = 0x10325476

			// temp buffers
			var a = 0,
				b = 0,
				c = 0,
				d = 0

				// Digest message
			for (i = 0; i < databytes.length / 64; i++) {
				// initialize run
				a = h0
				b = h1
				c = h2
				d = h3

				var ptr = i * 64

				// do 64 runs
				updateRun(fF(b, c, d), 0xd76aa478, bytes_to_int32(databytes, ptr), 7)
				updateRun(fF(b, c, d), 0xe8c7b756, bytes_to_int32(databytes, ptr + 4), 12)
				updateRun(fF(b, c, d), 0x242070db, bytes_to_int32(databytes, ptr + 8), 17)
				updateRun(fF(b, c, d), 0xc1bdceee, bytes_to_int32(databytes, ptr + 12), 22)
				updateRun(fF(b, c, d), 0xf57c0faf, bytes_to_int32(databytes, ptr + 16), 7)
				updateRun(fF(b, c, d), 0x4787c62a, bytes_to_int32(databytes, ptr + 20), 12)
				updateRun(fF(b, c, d), 0xa8304613, bytes_to_int32(databytes, ptr + 24), 17)
				updateRun(fF(b, c, d), 0xfd469501, bytes_to_int32(databytes, ptr + 28), 22)
				updateRun(fF(b, c, d), 0x698098d8, bytes_to_int32(databytes, ptr + 32), 7)
				updateRun(fF(b, c, d), 0x8b44f7af, bytes_to_int32(databytes, ptr + 36), 12)
				updateRun(fF(b, c, d), 0xffff5bb1, bytes_to_int32(databytes, ptr + 40), 17)
				updateRun(fF(b, c, d), 0x895cd7be, bytes_to_int32(databytes, ptr + 44), 22)
				updateRun(fF(b, c, d), 0x6b901122, bytes_to_int32(databytes, ptr + 48), 7)
				updateRun(fF(b, c, d), 0xfd987193, bytes_to_int32(databytes, ptr + 52), 12)
				updateRun(fF(b, c, d), 0xa679438e, bytes_to_int32(databytes, ptr + 56), 17)
				updateRun(fF(b, c, d), 0x49b40821, bytes_to_int32(databytes, ptr + 60), 22)
				updateRun(fG(b, c, d), 0xf61e2562, bytes_to_int32(databytes, ptr + 4), 5)
				updateRun(fG(b, c, d), 0xc040b340, bytes_to_int32(databytes, ptr + 24), 9)
				updateRun(fG(b, c, d), 0x265e5a51, bytes_to_int32(databytes, ptr + 44), 14)
				updateRun(fG(b, c, d), 0xe9b6c7aa, bytes_to_int32(databytes, ptr), 20)
				updateRun(fG(b, c, d), 0xd62f105d, bytes_to_int32(databytes, ptr + 20), 5)
				updateRun(fG(b, c, d), 0x2441453, bytes_to_int32(databytes, ptr + 40), 9)
				updateRun(fG(b, c, d), 0xd8a1e681, bytes_to_int32(databytes, ptr + 60), 14)
				updateRun(fG(b, c, d), 0xe7d3fbc8, bytes_to_int32(databytes, ptr + 16), 20)
				updateRun(fG(b, c, d), 0x21e1cde6, bytes_to_int32(databytes, ptr + 36), 5)
				updateRun(fG(b, c, d), 0xc33707d6, bytes_to_int32(databytes, ptr + 56), 9)
				updateRun(fG(b, c, d), 0xf4d50d87, bytes_to_int32(databytes, ptr + 12), 14)
				updateRun(fG(b, c, d), 0x455a14ed, bytes_to_int32(databytes, ptr + 32), 20)
				updateRun(fG(b, c, d), 0xa9e3e905, bytes_to_int32(databytes, ptr + 52), 5)
				updateRun(fG(b, c, d), 0xfcefa3f8, bytes_to_int32(databytes, ptr + 8), 9)
				updateRun(fG(b, c, d), 0x676f02d9, bytes_to_int32(databytes, ptr + 28), 14)
				updateRun(fG(b, c, d), 0x8d2a4c8a, bytes_to_int32(databytes, ptr + 48), 20)
				updateRun(fH(b, c, d), 0xfffa3942, bytes_to_int32(databytes, ptr + 20), 4)
				updateRun(fH(b, c, d), 0x8771f681, bytes_to_int32(databytes, ptr + 32), 11)
				updateRun(fH(b, c, d), 0x6d9d6122, bytes_to_int32(databytes, ptr + 44), 16)
				updateRun(fH(b, c, d), 0xfde5380c, bytes_to_int32(databytes, ptr + 56), 23)
				updateRun(fH(b, c, d), 0xa4beea44, bytes_to_int32(databytes, ptr + 4), 4)
				updateRun(fH(b, c, d), 0x4bdecfa9, bytes_to_int32(databytes, ptr + 16), 11)
				updateRun(fH(b, c, d), 0xf6bb4b60, bytes_to_int32(databytes, ptr + 28), 16)
				updateRun(fH(b, c, d), 0xbebfbc70, bytes_to_int32(databytes, ptr + 40), 23)
				updateRun(fH(b, c, d), 0x289b7ec6, bytes_to_int32(databytes, ptr + 52), 4)
				updateRun(fH(b, c, d), 0xeaa127fa, bytes_to_int32(databytes, ptr), 11)
				updateRun(fH(b, c, d), 0xd4ef3085, bytes_to_int32(databytes, ptr + 12), 16)
				updateRun(fH(b, c, d), 0x4881d05, bytes_to_int32(databytes, ptr + 24), 23)
				updateRun(fH(b, c, d), 0xd9d4d039, bytes_to_int32(databytes, ptr + 36), 4)
				updateRun(fH(b, c, d), 0xe6db99e5, bytes_to_int32(databytes, ptr + 48), 11)
				updateRun(fH(b, c, d), 0x1fa27cf8, bytes_to_int32(databytes, ptr + 60), 16)
				updateRun(fH(b, c, d), 0xc4ac5665, bytes_to_int32(databytes, ptr + 8), 23)
				updateRun(fI(b, c, d), 0xf4292244, bytes_to_int32(databytes, ptr), 6)
				updateRun(fI(b, c, d), 0x432aff97, bytes_to_int32(databytes, ptr + 28), 10)
				updateRun(fI(b, c, d), 0xab9423a7, bytes_to_int32(databytes, ptr + 56), 15)
				updateRun(fI(b, c, d), 0xfc93a039, bytes_to_int32(databytes, ptr + 20), 21)
				updateRun(fI(b, c, d), 0x655b59c3, bytes_to_int32(databytes, ptr + 48), 6)
				updateRun(fI(b, c, d), 0x8f0ccc92, bytes_to_int32(databytes, ptr + 12), 10)
				updateRun(fI(b, c, d), 0xffeff47d, bytes_to_int32(databytes, ptr + 40), 15)
				updateRun(fI(b, c, d), 0x85845dd1, bytes_to_int32(databytes, ptr + 4), 21)
				updateRun(fI(b, c, d), 0x6fa87e4f, bytes_to_int32(databytes, ptr + 32), 6)
				updateRun(fI(b, c, d), 0xfe2ce6e0, bytes_to_int32(databytes, ptr + 60), 10)
				updateRun(fI(b, c, d), 0xa3014314, bytes_to_int32(databytes, ptr + 24), 15)
				updateRun(fI(b, c, d), 0x4e0811a1, bytes_to_int32(databytes, ptr + 52), 21)
				updateRun(fI(b, c, d), 0xf7537e82, bytes_to_int32(databytes, ptr + 16), 6)
				updateRun(fI(b, c, d), 0xbd3af235, bytes_to_int32(databytes, ptr + 44), 10)
				updateRun(fI(b, c, d), 0x2ad7d2bb, bytes_to_int32(databytes, ptr + 8), 15)
				updateRun(fI(b, c, d), 0xeb86d391, bytes_to_int32(databytes, ptr + 36), 21)

				// update buffers
				h0 = _add(h0, a)
				h1 = _add(h1, b)
				h2 = _add(h2, c)
				h3 = _add(h3, d)
			}
			// Done! Convert buffers to 128 bit (LE)
			return int128le_to_hex(h3, h2, h1, h0).toUpperCase()
		}
	}

}(security));