var fs = require('fs');
var path = require('path');

var excel = require('excel4node');


// Create a new instance of a Workbook class
var workbook = new excel.Workbook();

var lang = "de"
var out = "www/res/translations/helper/out/"


var worksheet = workbook.addWorksheet("Hints!");
worksheet.cell(1, 1).string("Übersetzung in Spalte C einfügen!");
worksheet.cell(2, 1).string("text in {{...}} sind Platzhalter -> nicht übersetzen sondern an richtiger Stelle einfügen (Beispiel: {{count}} Einträge verschieben nach … -> move {{count}} items to …");
worksheet.cell(3, 1).string("\\n ist ein Zeilenumbruch und \\\" ist ein \". Diese müssen beibehalten werden");
worksheet.cell(4, 1).string("bitte auf einheitliche Groß- und Kleinschreibung achten");
worksheet.cell(5, 1).string("auf Textlänge achten (Länge sollte ungefähr der Vorlage entsprechen)");
worksheet.cell(6, 1).string("Rückfragen an info@markenapps.de oder 01791413736");

// Add Worksheets to the workbook
var base = "www/res/translations/"
var fileName = lang;
worksheet = workbook.addWorksheet(fileName);
fs.readFile(base + fileName + ".json", "utf8", function (err, text) {
    if (err) console.error(err);

    var t = JSON.parse(text);

    var row = 1;
    for (var key in t) {
        worksheet.cell(row, 1).string(key);
        var val = JSON.stringify(t[key])
        worksheet.cell(row++, 2).string(val.substring(1, val.length - 1));
    }
    worksheet.column(2).setWidth(50)

    base = "www/res/assets/"
    fileName = "caths_" + lang
    worksheet = workbook.addWorksheet(fileName);
    fs.readFile(base + fileName + ".json", "utf8", function (err, text) {
        if (err) console.error(err);

        var c = JSON.parse(text);

        var row = 1;
        for (var key in c) {
            if (c[key].title) {
                worksheet.cell(row, 1).string(key);
                var val = JSON.stringify(c[key].title)
                worksheet.cell(row++, 2).string(val.substring(1, val.length - 1));
            }
        }
        worksheet.column(2).setWidth(50)

        base = "www/res/assets/"
        fileName = "units_" + lang
        worksheet = workbook.addWorksheet(fileName);
        fs.readFile(base + fileName + ".json", "utf8", function (err, text) {
            if (err) console.error(err);

            var units = JSON.parse(text);

            var row = 1;
            units.forEach(unit => {
                worksheet.cell(row, 1).string(unit.title + " (plural)");
                worksheet.cell(row++, 2).string(unit.title);

                worksheet.cell(row, 1).string(unit.title + " (singular)");
                worksheet.cell(row++, 2).string(unit.title_sing);

                if (unit.name) {
                    worksheet.cell(row, 1).string(unit.title + " (short)");
                    worksheet.cell(row++, 2).string(unit.name);
                }
            });
            worksheet.column(2).setWidth(30)

            base = "store/Screenshots/"
            fileName = "meta"
            worksheet = workbook.addWorksheet(fileName);
            fs.readFile(base + fileName + ".json", "utf8", function (err, text) {
                if (err) console.error(err);

                var meta = JSON.parse(text)[lang];

                var row = 1;
                worksheet.cell(row++, 1).string("Achtung: manchmal ergeben mehrere Zeilen einen Satz. z.B. für func.text.zeile1 'So macht Einkaufen' und func.text.zeile2 'wieder Spaß!'");
                row++;
                for (var contentKey in meta) {
                    var content = meta[contentKey]
                    for (var textKey in content) {
                        var texts = content[textKey];
                        for (var l = 0; l < texts.length; l++) {
                            var line = texts[l];

                            var maxLength = 21;
                            if (textKey === "text_tablet") maxLength = l === 0 ? 38 : 45;
                            else if (contentKey === "func") maxLength = l === 0 ? 0 : 23; //limit app name does not make sence

                            worksheet.cell(row, 1).string(contentKey + "." + textKey + ".zeile" + (l + 1));
                            worksheet.cell(row, 2).string(line);
                            if (maxLength) worksheet.cell(row, 4).formula(`CONCATENATE( "noch verfügbare Zeichen ", ${maxLength}-LEN(C${row}) )`);
                            row++;
                        }
                    }
                }
                worksheet.column(2).setWidth(50)

                fileName = "store"
                worksheet = workbook.addWorksheet(fileName);
                var store = {
                    "desc_short": { "text": "Einkaufslisten erstellen, abarbeiten und teilen super einfach - probier's aus!", "length": 80 },
                    "subtitle": { "text": "Einfach schneller einkaufen.", "length": 30 },
                    "keywords": { "text": "Einkaufsliste,Einkaufszettel,Synchronisation,kostenlos,Spracheingabe,sync,einfach", "length": 70 },
                    "granny": { "text": "Oma" },
                    "party": { "text": "Feier" },
                    "gifts": { "text": "Geschenke" },
                    "diy_store": { "text": "Baumarkt" },
                    "tasks": { "text": "Aufgaben" },
                }
                var row = 1;
                var maxWidth = 0;
                for (var key in store) {
                    if (store[key].text) {
                        worksheet.cell(row, 1).string(key);
                        var val = JSON.stringify(store[key].text)
                        var width = val.length;
                        if (width > maxWidth) maxWidth = width;

                        worksheet.cell(row, 2).string(val.substring(1, val.length - 1));
                        worksheet.cell(row, 4).formula(`CONCATENATE( "noch verfügbare Zeichen ", ${store[key].length}-LEN(C${row}) )`);
                        row++
                    }
                }
                if (maxWidth) worksheet.column(2).setWidth(Math.min(100, maxWidth));
                workbook.write(out + lang + ".xlsx")
            });
        });
    });
});


