var excelToJson = require('convert-excel-to-json');
var fs = require('fs')


var basePath = "www/res/translations/";
var assetsPath = "www/res/assets/";
var bundlesPath = "www/res/bundles/";

var cathsTemplate = fs.readFileSync(assetsPath + "caths.json")
var unitsTemplate = fs.readFileSync(assetsPath + "units_de.json")


fs.readdir(basePath + "/helper/in/", (err, files) => {
    if (err) {
        console.error(err);
        return;
    }
    files.forEach(fileName => {
        console.log("fileName " + fileName);
        // if (fileName!=="de-tt.xlsx") return;


        var lang = fileName.substring(3, 5);
        const result = excelToJson({
            sourceFile: basePath + "/helper/in/" + fileName
        });


        delete result["Hints!"];
        var translation;
        for (var bundleName in result) {
            console.log("bundleName " + bundleName);
            if (bundleName === "de") {
                translation = bundelResultToJSON(result[bundleName]);

                var text = JSON.stringify(translation).replace(/\\\\"/g, "\"").replace(/\\\\n/g, "\\n")
                text = text.replace("dieeinkaufsliste.markenapps.de/web/de/uebertragen.html", "thatshoppinglist.markenapps.com/web/transfer.html")
                text = text.replace("dieeinkaufsliste.markenapps.de/web/de/verbinden.html", "thatshoppinglist.markenapps.com/web/connect.html")

                fs.writeFileSync(basePath + "/" + lang + ".json", text);

                var androidBundle = `<?xml version="1.0" encoding="utf-8"?>
<resources>
    <string name="app_name">${translation.app_title}</string>
    <string name="launcher_name">${translation.app_title}</string>
    <string name="activity_name">${translation.app_title}</string>
</resources>`

                fs.mkdirSync(bundlesPath + "android/values-" + lang + "/", { recursive: true });
                fs.writeFileSync(bundlesPath + "android/values-" + lang + "/strings.xml", androidBundle);

                var iosBundle = `CFBundleDisplayName = "${translation.app_title}";
CFBundleName = "${translation.app_title}";
NSMicrophoneUsageDescription = "${translation.NSMicrophoneUsageDescription || "To fill your list by voice input."}";
NSSpeechRecognitionUsageDescription = "${translation.NSMicrophoneUsageDescription || "To convert speech to text."}";
`
                fs.mkdirSync(bundlesPath + "ios/" + lang + ".lproj/", { recursive: true });
                fs.writeFileSync(bundlesPath + "ios/" + lang + ".lproj/InfoPlist.strings", iosBundle);
            } else if (bundleName === "units_de") {
                var units = JSON.parse(unitsTemplate);

                units.forEach(unit => {
                    delete unit.name;

                    var lines = result[bundleName].filter(line => {
                        return line.A.indexOf(unit.title + " (") === 0
                    })

                    lines.forEach(line => {
                        var prop = line.A.indexOf("(singular)") >= 0 ? "title_sing" : line.A.indexOf("(short)") >= 0 ? "name" : "title"

                        unit[prop] = line.C;
                    })
                })

                fs.writeFileSync(assetsPath + "units_" + lang + ".json", JSON.stringify(units))
            } else if (bundleName === "caths_de") {
                var cats;

                if (fs.existsSync(assetsPath + "caths_" + lang + ".json")) {
                    cats = fs.readFileSync(assetsPath + "caths_" + lang + ".json");
                }

                if (!cats) {
                    cats = JSON.parse(cathsTemplate);
                    delete cats.DIY;
                } else {
                    cats = JSON.parse(cats)
                }
                var and = translation.and;
                if (!and) console.warn(lang + ": no and word");

                if (result[bundleName].length !== Object.keys(cats).length) console.warn(lang + ": cat count diff");
                if (!cats.numberJoinWordRegExp) cats.numberJoinWordRegExp = "( |" + and + ")";
                else if (cats.numberJoinWordRegExp !== "( |" + and + ")") console.warn(lang + ": and word diff");

                result[bundleName].forEach(line => {
                    if (!line.C || !cats[line.A]) console.warn(lang + ": cat diff", line);
                    cats[line.A].title = line.C
                })

                fs.writeFileSync(assetsPath + "caths_" + lang + ".json", JSON.stringify(cats));
            } else if (bundleName === "meta") {
                var meta = JSON.parse(fs.readFileSync("store/Screenshots/mocitup-meta.json"));
                if (!meta[lang]) meta[lang] = {};

                result[bundleName].forEach((line, i) => {
                    if (i === 0) return;
                    //func.text.zeile1 or add.text_tablet.zeile3
                    var keyParts = line.A.split(".")
                    var name = keyParts[0]
                    var type = keyParts[1]
                    var idx = parseInt(keyParts[2].substring("zeile".length), 10);

                    if (!meta[lang][name]) meta[lang][name] = {};
                    if (!meta[lang][name][type]) meta[lang][name][type] = [];


                    if (!line.A) console.warn(lang + ": meta diff", line);
                    meta[lang][name][type][idx - 1] = line.C;
                })

                fs.writeFileSync("store/Screenshots/mocitup-meta.json", JSON.stringify(meta, null, 2));
            }
        }
    });
});


function bundelResultToJSON(bundelResult) {
    var result = {};
    bundelResult.forEach(line => {
        result[line.A] = line.C;
    })
    return result;
}


